package com.link.core.converter.util;

import java.io.Serializable;
import java.util.Map;

public class MapEntry<K, V> implements Map.Entry<K, V>, Serializable {
   private static final long serialVersionUID = 3663491177533615641L;
   private K key;
   private V value;

   public K getKey() {
      return this.key;
   }

   public void setKey(K key) {
      this.key = key;
   }

   public V getValue() {
      return this.value;
   }

   public V setValue(V value) {
      this.value = value;
      return this.value;
   }

   public int hashCode() {
      int prime = true;
      int result = 1;
      result = 31 * result + (this.key == null ? 0 : this.key.hashCode());
      result = 31 * result + (this.value == null ? 0 : this.value.hashCode());
      return result;
   }

   public boolean equals(Object obj) {
      if (this == obj) {
         return true;
      } else if (obj == null) {
         return false;
      } else if (this.getClass() != obj.getClass()) {
         return false;
      } else {
         MapEntry other = (MapEntry)obj;
         if (this.key == null) {
            if (other.key != null) {
               return false;
            }
         } else if (!this.key.equals(other.key)) {
            return false;
         }

         if (this.value == null) {
            if (other.value != null) {
               return false;
            }
         } else if (!this.value.equals(other.value)) {
            return false;
         }

         return true;
      }
   }

   protected void inject(Map.Entry<K, V> source) {
      this.key = source.getKey();
      this.value = source.getValue();
   }

   public MapEntry<K, V> clone() {
      MapEntry<K, V> other = new MapEntry();
      other.inject(this);
      return other;
   }

   public String toString() {
      StringBuffer sb = new StringBuffer();
      sb.append(this.key);
      sb.append('=');
      sb.append(this.value);
      return sb.toString();
   }
}
